#!/bin/bash

CWD=${PWD}
EXTERNAL_PATH=${PWD}/wazuh/src/external
CROSS_COMPILE=/usr/bin/arm-linux-gnueabihf-
HOST=arm-linux-gnueabihf

CFLAGS="-march=armv7-a -mfpu=vfpv3"

cd ${EXTERNAL_PATH}/audit-userspace  
autoreconf -f -i
./configure CC="${CROSS_COMPILE}gcc" CFLAGS="-fPIC ${CFLAGS}" CPPFLAGS="-fPIC"  --host=${HOST} --build=x86_64-linux-gnu  --disable-zos-remote --without-python --without-python3 --without-golang
make -j8
  
cd ${EXTERNAL_PATH}/cJSON
${CROSS_COMPILE}gcc -c -I. -fPIC ${CFLAGS}  *.c
rm -rf libcjson.a 
ar -rcv libcjson.a *.o
            
#libffi    
#libplist  
#msgpack   

make clean -C  ${EXTERNAL_PATH}/zlib            
make clean -C  ${EXTERNAL_PATH}/bzip2            
make -j8 CC=${CROSS_COMPILE}gcc CFLAGS="-fPIC ${CFLAGS}" -C  ${EXTERNAL_PATH}/zlib            
make -j8 CC=${CROSS_COMPILE}gcc CFLAGS="-fPIC ${CFLAGS}" -C  ${EXTERNAL_PATH}/bzip2            

#googletest  
#nlohmann  
   
cd ${EXTERNAL_PATH}/sqlite
${CROSS_COMPILE}gcc -c -I.  -fPIC ${CFLAGS} *.c
rm -rf libsqlite3.a 
ar -rcv libsqlite3.a *.o

cd ${EXTERNAL_PATH}/procps
${CROSS_COMPILE}gcc -c -I.  -fPIC ${CFLAGS} *.c
rm -rf libproc.a 
ar -rcv libproc.a *.o

cd ${EXTERNAL_PATH}/openssl
./Configure   linux-generic32
make CC=${CROSS_COMPILE}gcc CFLAGS="-fPIC ${CFLAGS}" -j8
 

cd ${EXTERNAL_PATH}/curl/
./configure CC=${CROSS_COMPILE}gcc CFLAGS="-fPIC ${CFLAGS}" CPPFLAGS="-fPIC" --host=${HOST}  --build=x86_64-linux  --with-ssl=../openssl  --disable-shared --disable-ares --disable-cookies --disable-crypto-auth --disable-ipv6 --disable-verbose --without-libidn --without-zlib --disable-ldap --disable-thread --disable-shared --host=arm-elf --build=x86_64 --without-ssl --without-libssh2
make -j8

cd ${EXTERNAL_PATH}/libarchive/
./configure CC=${CROSS_COMPILE}gcc CFLAGS="-fPIC ${CFLAGS}" --host=${HOST} --build=x86_64-linux-gnu --without-xml2 --without-expat --without-lz4 --without-lzma --without-zlib --without-bz2lib 
make -j8


cd ${EXTERNAL_PATH}/libdb/build_unix
make clean
../dist/configure CC=${CROSS_COMPILE}gcc CFLAGS="-fPIC ${CFLAGS}" --host=${HOST} --build=x86_64-linux-gnu 
make -j8

cd ${EXTERNAL_PATH}/libpcre2/
./configure CC=${CROSS_COMPILE}gcc CFLAGS="-fPIC ${CFLAGS}"  --host=${HOST} --build=x86_64-linux-gnu
make -j8

cd ${EXTERNAL_PATH}/libyaml/
./configure CC=${CROSS_COMPILE}gcc CFLAGS="-fPIC ${CFLAGS}" --host=${HOST} --build=x86_64-linux-gnu 
make -j8


cd ${EXTERNAL_PATH}/pacman/
autoreconf -f -i
./configure --host=${HOST} --build=x86_64-linux-gnu --without-libcurl CC=${CROSS_COMPILE}gcc CFLAGS="-fPIC ${CFLAGS}" CPPFLAGS=""  LIBCURL_CFLAGS="-I ${EXTERNAL_PATH}/curl/include" LIBCURL_LIBS="${EXTERNAL_PATH}/curl/lib/libcurl.la" LIBARCHIVE_CFLAGS="-I ${EXTERNAL_PATH}/libarchive/libarchive" LIBARCHIVE_LIBS="${EXTERNAL_PATH}/libarchive/libarchive.la" LIBSSL_CFLAGS="-I ${EXTERNAL_PATH}/openssl/include" LIBSSL_LIBS="${EXTERNAL_PATH}/openssl/libssl.a  ${EXTERNAL_PATH}/openssl/libcrypto.a"
make  CC=${CROSS_COMPILE}gcc V=1 

cd ${CWD}
